import java.io.IOException;
import java.io.StringReader;

import java.util.ArrayList;
import java.util.Iterator;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;




import org.dm.interopTestEDXLDE.DE_Dupe_Tracker;
import org.dm.interopTestEDXLDE.OpenDEConnection;
import org.dm.interopTestsCap.OpenCAPConnection;
import org.dm.interopUtil.XpathHelper;

/*
 * Created on Mar 28, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author HAMG
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OPEN_DE_Poll_Example_Distribution {
    

    public static final int ALL = 0;
    public static final int SENT = 1;
    public static final int POST = 2;
     
    private int pollMode = ALL;
    
    // this is the default you may wish to update
    private String timeString = "2006-08-08T14:24:20-03:00";

    String userId = "gham"; // put yours here
    String password = "gh1"; // put yours here
    String cogId = "1000";  // put yours here

    // INTEROPDEV
    String dmisURL = "http://interopdev.cmiservices.org/axis/services/EDXLDistributionElement";
    //PRODUCTION
    //String dmisURL = "https://interop.cmiservices.org/axis/services/EDXLDistributionElement";

    private long pause = 10000;//polling interval in milliseconds 
    private int max = 50000;// the incrementation of this variable can be commented out in the while loop below for continuous looping
       
    private OpenDEConnection d; 
    
    //for posting newly processed CAPS
    private OpenCAPConnection occ;
    ArrayList<String>  postCogIds =  new ArrayList<String> ();
  

    public static void main(String[] args) {
        // for test purposes you can 
        OPEN_DE_Poll_Example_Distribution poller = new OPEN_DE_Poll_Example_Distribution(SENT);
        
        poller.poll_unique();
    }
    
    // Constructor  that can be used outside the main
    
    OPEN_DE_Poll_Example_Distribution (int modeChoice ){
       pollMode = modeChoice;
       d = new OpenDEConnection(userId,password,cogId,dmisURL); 
       if  (pollMode==POST){
          timeString = d.getServerTime();
          System.out.println("Connected at:"+timeString);    
       } 
        
    }
   
   public void poll_unique(){

     int loopCount = 0;
     ArrayList  deMessageList = new ArrayList();
     
     // the Dupe_Tracker Class reads amanages and Writes a datafile for Dupe Checking
     DE_Dupe_Tracker tracker = new DE_Dupe_Tracker("C:\\Documents and Settings\\Hamg\\My Documents\\_Interop\\2006Interop\\HamTestSetup\\DupeList.txt");
     ArrayList <String> onFileIds = new ArrayList <String> (tracker.getDupeList()); 
     
      
     // Set the polling action against OPEN 
     // Each loop involves one data pull
     while (loopCount < max){
         loopCount++; // comment out to create unending loop
         
         switch (pollMode){
           case ALL: deMessageList = d.getAllDEasArraylist();
           case SENT: deMessageList = d.getAllDEasArraylistBySentTime(timeString);
           case POST: deMessageList = d.getAllDEasArraylistByPostTime(timeString);       
         }
 
         // Loop through the poll results
         Iterator allDEsIterator = deMessageList.iterator();
         while (allDEsIterator.hasNext()){
             Document document = null;
             DocumentBuilder builder = null;
             String distributionId="";
             String senderId = "";
             // begin testing each DE instance for duplicate id
             String deInXML = (String)allDEsIterator.next();
             try {
                 builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
             } catch (ParserConfigurationException e) {
                 // TODO Auto-generated catch block
                 e.printStackTrace();
             }

             // turn your XML string into a parsable InputSource              
             try {
                  InputSource s = new InputSource(new StringReader(deInXML));
                   document = builder.parse(s);
              } catch (SAXException e1) {
                  // TODO Auto-generated catch block
                  e1.printStackTrace();
              } catch (IOException e1) {
                  // TODO Auto-generated catch block
                  e1.printStackTrace();
              }
             
//           Evaluate an XPath expression against the Document for id and sender
             XPath xpath = XPathFactory.newInstance().newXPath();
             String expression = "/EDXLDistribution/distributionID";
             try {
                distributionId = (String) xpath.evaluate(expression, document);
//                System.out.println("Distribution Id = "+ distributionId);       
             } catch (XPathExpressionException e2) {
                // TODO Auto-generated catch block
                e2.printStackTrace();
                System.exit(1);
             }
             expression = "/EDXLDistribution/senderID";
             try {
                senderId = (String) xpath.evaluate(expression, document);
//                System.out.println("Sender Id = "+ senderId);       
             } catch (XPathExpressionException e2) {
                // TODO Auto-generated catch block
                e2.printStackTrace();
                System.exit(1);
             }
             
             // match for dupes
             String matchString = distributionId+senderId;
             int count = 0;
             int listSize = onFileIds.size();
             while (count < listSize){
                 if (matchString.equals(onFileIds.get(count))){
                     System.out.println("Duplicate found for: ");
                     System.out.println("Distribution Id = "+ distributionId);                     
                     System.out.println("Sender Id = "+ senderId);                     
                     break;
                 }
                 count++;
                 if (count == listSize){
                     onFileIds.add(matchString);
                     // this is where you would call your system to process the new result!!
                     this.processDEContent(deInXML);
                 }  
                                    
             }// end while
             
        }//end while big loop
        // keep the dupe file up to date
        tracker.setDupeList(onFileIds);
        tracker.writeDupeFile();
        //delay is executed here
        try {
            System.out.println ("Count = "+ loopCount);
            System.out.println("pause for "+pause);
            Thread.sleep(pause);

       } catch (InterruptedException e3) {
           // TODO Auto-generated catch block
           e3.printStackTrace();
       }
     }
     System.exit(0);
   }// end pollUnique   
 
  private void processDEContent(String deInstance){
      
      // call this function if you wish to strip and repost a possile enclose CAP 1.1 content
     // repostPostCAPContent(deInstance); 
      
      System.out.println("New DE Found:");
      System.out.println(deInstance);
  }
  
 // this function determinse if the de has CAP content and reposts the CAP to specifc cogs
 // uses my XpathHelper class
        
 @SuppressWarnings({ "unused" })
private void repostPostCAPContent(String deInstance){

         String expression = "/EDXLDistribution/contentObject/xmlContent/embeddedXMLContent/alert";
         NodeList contentNodes;
         
         contentNodes = XpathHelper.findContent(deInstance, expression);
         if (contentNodes.getLength()>0){
             occ = new OpenCAPConnection ("userid", "password", "cogid", "http://interopdev.cmiservices.org/axis/services/CAP1_1");

//             postCogIds.add("2506");
//             postCogIds.add("1000");
             postCogIds.add("1737");         
             postCogIds.add("2");
         }
         for (int i=0;i<contentNodes.getLength();i++){
//          System.out.println("SubNodes: " + contentNode.getLength());
            System.out.println("Node name is: " + contentNodes.item(i).getNodeName());
            String xmlString = XpathHelper.node_to_String(contentNodes.item(i)); 
            System.out.println(xmlString);
            occ.postXmlStringToOpen(xmlString,postCogIds); 
          }        
     
 }
        

   
   
   
    
}