import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Iterator;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;


import org.w3c.dom.Document;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;


import org.dm.interopTestsCap.Dupe_Tracker;
import org.dm.interopTestsCap.OpenCAPConnection;

/*
 * Created on Sep 3, 2006
 */

/**
 * @author HAMG
 *
 * This is a sample poller that will work. You may wish to use the more efficient retrieval methods
 * in the new interface in its place.
 */
public class Open_CAP1_1_Poll_Example_Distribution {

    public static void main(String[] args) {
        Open_CAP1_1_Poll_Example_Distribution poller = new Open_CAP1_1_Poll_Example_Distribution();
        poller.poll_unique();
    }
    
   public void poll_unique(){


     long pause = 10000; 
     int max = 50000;// the incrementation of this variable can be commented out in the while loop below for continuous looping
     int loopCount = 0;

     String userId = "userid"; // put yours here
     String password = "Password"; // put yours here
     String cogId = "1737";  // put yours here

     // INTEROPDEV
     String dmisURL = "http://interopdev.cmiservices.org/axis/services/CAP1_1";
     //PRODUCTION
     //String dmisURL = "https://interop.cmiservices.org/axis/services/CAP1_1";

     
     OpenCAPConnection oc = new OpenCAPConnection(userId,password,cogId,dmisURL); 

     ArrayList  capMessageList = new ArrayList();
     
     // the Dupe_Tracker Class reads amanages and Writes a datafile for Dupe Checking
     Dupe_Tracker tracker = new Dupe_Tracker("C:\\Documents and Settings\\Hamg\\My Documents\\_Interop\\2006Interop\\HamTestSetup\\CapDupeList.txt");
     ArrayList<String>  onFileIds = new ArrayList<String> (tracker.getDupeList()); 
     

     // Set the polling action against OPEN 
     // Each loop involves one data pull
     while (loopCount < max){
         loopCount++; // comment out to create unending loop
         
         // Get an Array list of all DE's available from the last x days
         capMessageList = oc.getCapsXdays(10,true);

         // Loop through the poll results
         Iterator capListIterator = capMessageList.iterator();
         while (capListIterator.hasNext()){
             Document document = null;
             DocumentBuilder builder = null;
             String alertId="";
             String senderId = "";
             // begin testing each DE instance for duplicate id
             String capInXml = (String)capListIterator.next();
             try {
                 builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
             } catch (ParserConfigurationException e) {
                 // TODO Auto-generated catch block
                 e.printStackTrace();
             }

             // turn your XML string into a parsable InputSource              
             try {
                  InputSource s = new InputSource(new StringReader(capInXml));
                   document = builder.parse(s);
              } catch (SAXException e1) {
                  // TODO Auto-generated catch block
                  e1.printStackTrace();
              } catch (IOException e1) {
                  // TODO Auto-generated catch block
                  e1.printStackTrace();
              }
             
//           Evaluate an XPath expression against the Document for id and sender
             XPath xpath = XPathFactory.newInstance().newXPath();
             String expression = "/alert/identifier";
             try {
                alertId = (String) xpath.evaluate(expression, document);
 //               System.out.println("Identifier = "+ alertId);       
             } catch (XPathExpressionException e2) {
                // TODO Auto-generated catch block
                e2.printStackTrace();
                System.exit(1);
             }
             expression = "/alert/sender";
             try {
                senderId = (String) xpath.evaluate(expression, document);
 //               System.out.println("Sender Id = "+ senderId);       
             } catch (XPathExpressionException e2) {
                // TODO Auto-generated catch block
                e2.printStackTrace();
                System.exit(1);
             }
             
             // match for dupes
             String matchString = alertId+senderId;
//             System.out.println("Matchstring = "+ matchString);              
             int count = 0;
             int listSize = onFileIds.size();
             System.out.println("MatchListSize = "+ listSize);            
             while (count < listSize){
                 if (matchString.equals(onFileIds.get(count))){
                     System.out.println("Duplicate found for: ");
                     System.out.println("identifier = "+ alertId);                     
                     System.out.println("sender = "+ senderId);                     
                     break;
                 }
                 count++;
                 if (count == listSize){
                     onFileIds.add(matchString);
                     // this is where you would call your system to process the new result!!
                     System.out.println("New Alert Found:");
                     System.out.println(capInXml);
           
                }  
                                    
             }// end while
             
        }//end while big loop
        // keep the dupe file up to date
        tracker.setDupeList(onFileIds);
        tracker.writeDupeFile();
        //delay is executed here
        try {
            System.out.println ("Count = "+ loopCount);
            System.out.println("pause for "+pause);
            Thread.sleep(pause);

       } catch (InterruptedException e3) {
           // TODO Auto-generated catch block
           e3.printStackTrace();
       }
     }
     System.exit(0);
   }// end pollUnique    
}