/*
 * Created on Jan 11, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.dm.interopTestEDXLDE;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.RemoteException;
import java.util.ArrayList;

import javax.xml.rpc.ServiceException;

import org.cmis.interopserver.services.edxlde.EDXLDistributionElementService;
import org.cmis.interopserver.services.edxlde.EDXLDistributionElementServiceLocator;
import org.cmis.interopserver.services.edxlde.EDXLDistributionElementSoapBindingStub;
//import org.dm.interopUtil.ISO8601Conversion;


/**
 * @author HAMG
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OpenDEConnection {
    String userId;
    String password;
    String cogId;
    String dmisURL;
    EDXLDistributionElementService service = new EDXLDistributionElementServiceLocator();
    URL svcURL;
    EDXLDistributionElementSoapBindingStub de; 
    
   
   // the constructor establishes the DMIS connection
    public OpenDEConnection (String id, String pwd, String cog, String url ){
        userId = id;
        password = pwd;
        cogId = cog;
        dmisURL=url;
        try {
            //svcURL = "http://interopdev.cmiservices.org/axis/services/EDXLDistributionElement";");
            svcURL = new URL(dmisURL); 
            System.out.println("Invoking service at " + svcURL.toString());
            de =(EDXLDistributionElementSoapBindingStub) service.getEDXLDistributionElement(svcURL);
            de.setUsername(cogId+"/"+userId);
            de.setPassword(password);           
           } catch (MalformedURLException e) {
               // TODO Auto-generated catch block
            e.printStackTrace();
           } catch (ServiceException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
 
    
  public String getServerTime(){
      try {
		return de.getServerTime();
	} catch (RemoteException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
      return "";
	}
     
  };
      

   
  // reads the file for posting, then calls method below to post   
  public boolean postDeFileToOpen(String fileName, long[] cogs){

      // Read the file
      String xml="";
      StringBuffer buf= new StringBuffer();
      File inFile = new File(fileName);
      FileReader in;
      try {
          in = new FileReader(inFile);
          BufferedReader r = new BufferedReader(in);
          boolean eof=false;
          while (!eof){
             String line = r.readLine();
             if (line==null){
                eof=true;
             }else{                   
               buf.append(line);
               buf.append("\n");
             }
          }

//          xml= new String(buf);
          xml =buf.toString() ; 
//          System.out.println("The file before posting: \n"+xml);     
          } catch (FileNotFoundException e) {
             // TODO Auto-generated catch block
             e.printStackTrace();
             return false;
          } catch (IOException e) {
             // TODO Auto-generated catch block
             e.printStackTrace();
             return false;
      } 

      return postDeXmlToOpen (xml, cogs);
  }

   // posts a deXML strema to OPEN
   public boolean postDeXmlToOpen (String xml, long[] cogs){
      
       try {
           System.out.println(de.postEdxlDEMessage(cogs,xml));
       } catch (RemoteException e) {
           System.err.println("Did not post correctly" );
           // TODO Auto-generated catch block
           e.printStackTrace();
           System.err.println(e.getMessage());
           return false;
       }             
       return true;
   } 



    public ArrayList<String> getAllDEasArraylist(){
        String [] deArray;
        ArrayList<String>  deMessageList = new ArrayList<String>();
        int cog = Integer.parseInt(cogId);
         
        try {
            deArray = de.getAllEdxlDEMsgs(cog);
            if (deArray!=null){  
               for (int i=0; i< deArray.length;i++){
                 deMessageList.add(deArray[i]);
                }
            }                       
           } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
           }
         return deMessageList;
    }; 
    
    public ArrayList<String> getAllDEasArraylistByPostTime(String posted){
        String [] deArray;
        ArrayList<String>  deMessageList = new ArrayList<String>();
 //       int cog = Integer.parseInt(cogId);
         
        try {
            deArray = de.getEdxlDEMsgsByPostedDate(posted);
            if (deArray!=null){  
               for (int i=0; i< deArray.length;i++){
                 deMessageList.add(deArray[i]);
                }
            }                       
           } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
           }
         return deMessageList;
    }; 

    
    public ArrayList<String> getAllDEasArraylistBySentTime(String sent){
        String [] deArray;
        ArrayList<String>  deMessageList = new ArrayList<String>();
 //       int cog = Integer.parseInt(cogId);
         
        try {
            deArray = de.getEdxlDEMsgsBySentDate(sent);
            if (deArray!=null){  
               for (int i=0; i< deArray.length;i++){
                 deMessageList.add(deArray[i]);
                }
            }                       
           } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
           }
         return deMessageList;
    };     
    
    
    public String getDEasXMLStreamByPost(String sent){
        String [] deArray;
        String deMessageString="";
 //       long cog = Long.parseLong(cogId);
         
        try {
            deArray = de.getEdxlDEMsgsByPostedDate(sent);  
            if (deArray!=null) {
                for (int i=0; i< deArray.length;i++){
                   deMessageString = deMessageString + deArray[i]+"\n";
                }             
            }else{
                deMessageString = "<message> no records found </message>"; 
                             
            }
         } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
           }
         return deMessageString;
    }; 
   
    public String getDEasXMLStreamBySent(String sent){
        String [] deArray;
        String deMessageString="";
 //      long cog = Long.parseLong(cogId);
         
        try {
            deArray = de.getEdxlDEMsgsBySentDate(sent); 
            if (deArray!=null) {
                for (int i=0; i< deArray.length;i++){
                   deMessageString = deMessageString + deArray[i]+"\n";
                }             
            }else{
                deMessageString = "<message> no records found </message>"; 
                             
            }
         } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
           }
         return deMessageString;
    }; 

          
 
    public String getAllDEasXMLStream(){
        String [] deArray;
        String deMessageString="";
        long cog = Long.parseLong(cogId);
         
        try {
            deArray = de.getAllEdxlDEMsgs(cog);  
            for (int i=0; i< deArray.length;i++){
                deMessageString = deMessageString + deArray[i]+"\n";
            
             
            }            
           } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
           }
         return deMessageString;
    }; 
    
    
    public String getSpecificEDXLDE(String id, String sender){

        String deXMLString ="";
        String uniqueId = id+" "+sender; 

        try {
            deXMLString = de.getEdxlDEMessage(uniqueId);  
        } catch (RemoteException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return deXMLString;
    };
 
            
}
