/*
 * Created on Jan 11, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.dm.interopTestNWEM;

import gov.noaa.nws.hazcollect.support.view.CogGeoFipsCodeImpl;

import java.io.*;
import java.net.*;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Calendar;

import javax.xml.rpc.ServiceException;

import org.cmis.interopserver.beans.SimpleCOG;
import org.cmis.interopserver.services.nwem.NWEMService;
import org.cmis.interopserver.services.nwem.NWEMServiceLocator;
import org.cmis.interopserver.services.nwem.NWEMSoapBindingStub;



/**
 * @author HAMG
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OpenNWEMConnection {
    String userId;
    String password;
    String cogId;
    String dmisURL;
    NWEMService service = new NWEMServiceLocator();
    URL svcURL;
    NWEMSoapBindingStub nwem; 
    
   
   // the constructor establishes the DMIS connection
    public OpenNWEMConnection (String id, String pwd, String cog, String url ){
        userId = id;
        password = pwd;
        cogId = cog;
        dmisURL=url;
        try {
   			//svcURL = new URL("https://interop.cmiservices.org/axis/services/CAP");
            svcURL = new URL(dmisURL); 
            System.out.println("Invoking service at " + svcURL.toString());
            nwem = (NWEMSoapBindingStub) service.getNWEM(svcURL);
            nwem.setUsername(cogId+"/"+userId);
            nwem.setPassword(password);           
		   } catch (MalformedURLException e) {
			   // TODO Auto-generated catch block
			e.printStackTrace();
		   } catch (ServiceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
    
    // a test that the connection is in place
    public boolean ping() {
        try {
   			String pingResult = nwem.ping();
            if (pingResult == null)
                System.out.println("Did not receive result as expected");
            else if (pingResult.length() == 0)
                System.out.println("Did not receive result as expected");
            else if (pingResult.equalsIgnoreCase("pong"))         
                return true;
         
        } catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
	     }
		return false;
    }
    

    // reads a PRE-VALIDATED CAP1.1 or CAP 1. file,
    // sends the resulting XML String to  translates it first to an Incident.com object, and
    // then to a DMIS object posting the result to the DMIS cogs represented by the Arraylist of Cogids
    // Returns true is successful
    // Returns false if exceptions of any kind are thrown.  Needs further exception handling code
    public boolean postNwemFileToOpen(String fileName, String timeZone, ArrayList cogs){
        // Read the file
        String xml="";
        StringBuffer buf= new StringBuffer();
        File inFile = new File(fileName);
        FileReader in;
        try {
            in = new FileReader(inFile);
            BufferedReader r = new BufferedReader(in);
            boolean eof=false;
            while (!eof){
               String line = r.readLine();
               if (line==null){
                  eof=true;
               }else{
                 buf.append(line);
               }
            }
            xml= new String(buf);
            return postNwemXmlStringToOpen(xml,timeZone, cogs);       
            } catch (FileNotFoundException e) {
               // TODO Auto-generated catch block
               e.printStackTrace();
               return false;
            } catch (IOException e) {
               // TODO Auto-generated catch block
               e.printStackTrace();
               return false;
        }
    }

    // translates a prevalidated XML String to a DM Alert Object via an incident.com 
    // alert, posts to OPEN by calling postDmAlertToOpen 
    // Returns false if exceptions of any kind are thrown.  
    // Needs further exception handling code
    public boolean postNwemXmlStringToOpen(String xml,String timeZone, ArrayList cogs )
    {       
        //Convert the xml string to a DMIS cap object 
        com.incident.cap.Alert incidentCap = new com.incident.cap.Alert();
        org.cmis.interopserver.beans.cap1_1.Alert dmisAlert = new org.cmis.interopserver.beans.cap1_1.Alert(); 
        incidentCap = com.incident.cap.Alert.parse(xml);
        
        dmisAlert = ArtCapDmisTranslator.toDmisCap(incidentCap); 
        return postNwemAlertToOpen(dmisAlert,timeZone,cogs);
    }
  
  
    // posts a DM Alert Object to the specified cogs
    // Returns false if exceptions of any kind are thrown.  
    // Needs further exception handling code  
    public boolean postNwemAlertToOpen(org.cmis.interopserver.beans.cap1_1.Alert dmisAlert,String timeZone, ArrayList cogs){
 
        SimpleCOG[] postCogs; 
        // if the Arraylist has cog ids build an array of simple cog to post to
        postCogs = null;
        if (cogs.size()>0){
            postCogs = new SimpleCOG [cogs.size()];                     
            for (int i = 0; i < postCogs.length;i++){
                postCogs[i]= new SimpleCOG();
                postCogs[i].setId(Long.parseLong ((String)(cogs.get(i))));
                postCogs[i].setName("Not Specified");
            }
        }
        
         
        // this next line is designed to cause a unique identifier for regression test situations
        // It should be commented out for any real processing of strongly identified messages messages 
//        dmisAlert.setIdentifier(dmisAlert.getIdentifier()+String.valueOf(System.currentTimeMillis()));

        // post to "all cogs" in the evet the coglist is empty or to the cogs specified.
        try {
            if (postCogs==null){
                nwem.postNWEM(dmisAlert,timeZone,postCogs);
            }else{
                nwem.postNWEM(dmisAlert,timeZone,postCogs);
            }

		  } catch (RemoteException e) {
		   	// TODO Auto-generated catch block
		   	e.printStackTrace();
            return false;
		  }      
        return true;
    }
    
    public String getNwem(String sender, String identifier, boolean One_1){
        String xml="";
        org.cmis.interopserver.beans.cap1_1.Alert alert1 = null;
        com.incident.cap.Alert incidentAlert = new com.incident.cap.Alert();
        try{
           alert1 = new org.cmis.interopserver.beans.cap1_1.Alert();
           String findString = sender+":"+identifier;
           alert1 = nwem.getAlert(findString);
           if ((alert1==null)||(alert1.getIdentifier()==null)){
               System.out.println("Null value returned. Identifier string not found.");
           }else{
               if (alert1.getIdentifier().equals(identifier)){
                 // temporary category test
                // System.out.println("Category length = "+alert1.getInfo(0).getCategory().length) ; 
                 //end temporary category test
                 incidentAlert = ArtCapDmisTranslator.toArtCap(alert1);
                 if (One_1){
                     xml = incidentAlert.toString();
                 }else {
                     xml = incidentAlert.toCAP10();
                 }
               }else{
                   System.out.println("MismatchedIdentifier returned:" +alert1.getIdentifier());
               }
           }                              
           
       } catch (Exception ex) {
          ex.printStackTrace();
       }
       return xml;
    }

  // gets all caps over X days old output as XML in 1.1 or 1.0 format
  // with the <?xml version="1.0" encoding="UTF-8"?> stripped fro the front
  // so it does not hurt well-formedness as a set of alerts packed in one XML document 
    
   public  ArrayList <String> getNwemsXdays(int daysAgo, boolean One_1){
 //       org.cmis.interopserver.beans.cap1_1.Alert alert1 = null;
        org.cmis.interopserver.beans.cap1_1.Alert[] alertSet = null;
        com.incident.cap.Alert artAlert;
        ArrayList <String> artCapsXML =new ArrayList <String> ();
        Calendar cal;
          
        try{
 
            //sets retreival time of the last daysAgodays
            cal=Calendar.getInstance();
            cal=nwem.getServerTime();
            int minusDays = 0 - daysAgo;
            cal.add(Calendar.DATE,minusDays);              

            alertSet = nwem.getAlertsBySentDate(cal);

            for (int i=0; i<alertSet.length; i++){
 //               System.out.println(alertSet[i].getSent());
                artAlert = new com.incident.cap.Alert();
                artAlert = ArtCapDmisTranslator.toArtCap(alertSet[i]);
                if (One_1){
//                    artCapsXML.add(artAlert.toString());
                    String temp = artAlert.toString();
                    artCapsXML.add(temp.substring(39));                    
                }else {
//                    artCapsXML.add(artAlert.toCAP10());
                    String temp = artAlert.toCAP10(); 
                    artCapsXML.add(temp.substring(39));                   
                }
  
            }
                   
        }catch (Exception ex) {
             ex.printStackTrace();
        }
        return artCapsXML;
    }
/*    
    public String getAvaliableCogsXML(){
        SimpleCOG [] cogSet = null;
        String cogsXML = null;          
        try{
            cogSet = nwem..getCogs();
            cogsXML="<cogs>" +"\n";
            for (int i=0; i<cogSet.length; i++){
                cogsXML= cogsXML +"   <cog>" +"\n";
                cogsXML= cogsXML +"      <cogId>"+cogSet[i].getId()+"</cogId>" +"\n";
                cogsXML= cogsXML +"      <cogName>"+cogSet[i].getName()+"</cogName>" +"\n";
                cogsXML= cogsXML +"   </cog>" +"\n";
            }
            cogsXML=cogsXML + "</cogs>" +"\n";                   
        }catch (Exception ex) {
             ex.printStackTrace();
        }
        return cogsXML;
    }
*/
    public String getMyCogXML(){
        SimpleCOG  cog = null;
        String cogXML = null;          
        try{
            cog = nwem.getMyCog();
            cogXML= "<cog>" +"\n";
            cogXML= cogXML +"   <cogId>"+cog.getId()+"</cogId>" +"\n";
            cogXML= cogXML +"   <cogName>"+cog.getName()+"</cogName>" +"\n";
            cogXML= cogXML +"</cog>" +"\n";
        }catch (Exception ex) {
             ex.printStackTrace();
        }
        return cogXML;
    }
    
    public SimpleCOG getMyCog(){
        SimpleCOG  cog = null;         
        try{
            cog = nwem.getMyCog();
        }catch (Exception ex) {
             ex.printStackTrace();
        }
        return cog;
    }
     
    public boolean isConnectionCogNwemAuthorized(){
        boolean authorized = false;
        try {
			authorized = nwem.isCogAuthorized(cogId);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
      return authorized;  
    } 
    public String getHCSServerMode(){
       String mode = "untested"; 
       try {
		     mode = nwem.getHCSMode();
	} catch (RemoteException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} 
    return mode;
    };  
    
    public String getAuxDataXML(){
       String xml = "";
       String xmlList = "";
       
       CogGeoFipsCodeImpl []  auxDataSet;
       try {
		auxDataSet = nwem.getNWEMAuxData("1000");
	   } catch (RemoteException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
      return xml;
	   }
      System.out.println(auxDataSet.length);
      xmlList = "<auxData>"+"\n";
      for (int i=0; i<auxDataSet.length;i++){

          if (auxDataSet[i]!=null){
              xml = "";
              xml = xml + "   <entry>\n";
              xml = xml + "       <cogId>"+auxDataSet[i].getCogId()+"</cogID>\n";
              xml = xml + "       <countyFipsCd>"+auxDataSet[i].getCountyFipsCd()+"</countyFipsCd>\n";
              xml = xml + "       <countyName>"+auxDataSet[i].getCountyName()+"</countyName>\n";
              xml = xml + "       <geoType>"+auxDataSet[i].getGeoType()+"</geoType>\n";
              xml = xml + "       <stateCd>"+auxDataSet[i].getStateCd()+"</stateCd>\n";
              xml = xml + "       <stateFips>"+auxDataSet[i].getStateFips()+"</stateFips>\n";
              xml = xml + "       <stateName>"+auxDataSet[i].getStateName()+"</stateName>\n";
              xml = xml + "       <zoneCd>"+auxDataSet[i].getZoneCd()+"</zoneCd>\n";
              xml = xml + "       <zoneName>"+auxDataSet[i].getZoneName()+"</zoneName>\n";
              xml = xml + "   </entry>\n";
              xmlList = xmlList+xml;
              System.out.println(i);
         }else{
             System.out.println("array value was null");
         }
       
      }
      xmlList=xmlList+"</auxData>" + "\n";
       return xmlList;
       
    }
    
            
}
