/*
 * Created on Jan 11, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.dm.interopTestsCap;

import java.io.*;
import java.net.*;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Calendar;

import javax.xml.rpc.ServiceException;

import org.cmis.interopserver.beans.SimpleCOG;
import org.cmis.interopserver.beans.cap1_1.*;
import org.cmis.interopserver.services.cap1_1.CAP1_1Service;
import org.cmis.interopserver.services.cap1_1.CAP1_1ServiceLocator;
import org.cmis.interopserver.services.cap1_1.CAP1_1SoapBindingStub;
import org.dm.interopUtil.*;
import org.joda.time.DateTime;
import org.joda.time.MutableDateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;



/**
 * @author HAMG
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OpenCAPConnection {
    String userId;
    String password;
    String cogId;
    String dmisURL;
    CAP1_1Service service = new CAP1_1ServiceLocator();
    URL svcURL;
    CAP1_1SoapBindingStub cap; 
	DateTimeFormatter fmt = DateTimeFormat.forPattern("YYYY-MM-dd'T'HH:mm:ssZZ");
    
    public static final int ALL_BY_SENT_DATE = 0;
    public static final int POSTED_BY_SENT_DATE = 1;
    public static final int RECEIVED_BY_SENT_DATE = 2;
    public static final int GLOBAL_BY_SENT_DATE = 3;
    public static final int ALL_BY_POST_DATE = 4;
    public static final int POSTED_BY_POST_DATE = 5;
    public static final int RECEIVED_BY_POST_DATE = 6;
    public static final int GLOBAL_BY_POST_DATE = 7; 
    
    public static final int ALL = 0;
    public static final int POSTED = 1;
    public static final int RECEIVED = 2;
    public static final int GLOBAL = 3;
       
     
   // the constructor establishes the OPEN connection
    public OpenCAPConnection (String id, String pwd, String cog, String url ){
        userId = id;
        password = pwd;
        cogId = cog;
        dmisURL=url;
        try {
   			//svcURL = new URL("https://interop.cmiservices.org/axis/services/CAP");
            svcURL = new URL(dmisURL); 
            System.out.println("Invoking service at " + svcURL.toString());
            cap = (CAP1_1SoapBindingStub) service.getCAP1_1(svcURL);
            cap.setUsername(cogId+"/"+userId);
            cap.setPassword(password);           
		   } catch (MalformedURLException e) {
			   // TODO Auto-generated catch block
			e.printStackTrace();
		   } catch (ServiceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
    
    public String getCogID(){
        return cogId;
    };
    
    
    // a test that the connection is in place
    public boolean ping() {
        try {
   			String pingResult = cap.ping();
            if (pingResult == null)
                System.out.println("Did not receive result as expected");
            else if (pingResult.length() == 0)
                System.out.println("Did not receive result as expected");
            else if (pingResult.equalsIgnoreCase("pong"))         
                return true;
         
        } catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
	     }
		return false;
    }
    

    // reads a PRE-VALIDATED CAP1.1 or CAP 1. file,
    // sends the resulting XML String to  translates it first to an Incident.com object, and
    // then to a DMIS object posting the result to the DMIS cogs represented by the Arraylist of Cogids
    // Returns true is successful
    // Returns false if exceptions of any kind are thrown.  Needs further exception handling code
    public boolean postFileToOpen(String fileName, ArrayList <String> cogs){
        // Read the file
        String xml="";
        StringBuffer buf= new StringBuffer();
        File inFile = new File(fileName);
        FileReader in;
        try {
            in = new FileReader(inFile);
            BufferedReader r = new BufferedReader(in);
            boolean eof=false;
            while (!eof){
               String line = r.readLine();
               if (line==null){
                  eof=true;
               }else{
                 buf.append(line);
               }
            }
            xml= new String(buf);
            return postXmlStringToOpen(xml, cogs);       
            } catch (FileNotFoundException e) {
               // TODO Auto-generated catch block
               e.printStackTrace();
               return false;
            } catch (IOException e) {
               // TODO Auto-generated catch block
               e.printStackTrace();
               return false;
        }
    }

    // translates a prevalidated XML String to a DM Alert Object via an incident.com 
    // alert, posts to OPEN by calling postDmAlertToOpen 
    // Returns false if exceptions of any kind are thrown.  
    // Needs further exception handling code
    public boolean postXmlStringToOpen(String xml,ArrayList <String> cogs )
    {       
        //Convert the xml string to a DMIS cap object 
        com.incident.cap.Alert incidentCap = new com.incident.cap.Alert();
        org.cmis.interopserver.beans.cap1_1.Alert dmisAlert = new org.cmis.interopserver.beans.cap1_1.Alert(); 
        incidentCap = com.incident.cap.Alert.parse(xml);
        
        dmisAlert = ArtCapDmisTranslator.toDmisCap(incidentCap); 
        return postDmAlertToOpen(dmisAlert,cogs);
    }
  
  
    // posts a DM Alert Object to the specified cogs
    // Returns false if exceptions of any kind are thrown.  
    // Needs further exception handling code  
    public boolean postDmAlertToOpen(org.cmis.interopserver.beans.cap1_1.Alert dmisAlert, ArrayList <String> cogs){
 
        SimpleCOG[] postCogs; 
        // if the Arraylist has cog ids build an array of simple cog to post to
        postCogs = null;
        if (cogs.size()>0){
            postCogs = new SimpleCOG [cogs.size()];                     
            for (int i = 0; i < postCogs.length;i++){
                postCogs[i]= new SimpleCOG();
                postCogs[i].setId(Long.parseLong ((String)(cogs.get(i))));
                postCogs[i].setName("Not Specified");
            }
        }
        
         
        // this next line is designed to cause a unique identifier for regression test situations
        // It should be commented out for any real processing of strongly identified messages messages 
//        dmisAlert.setIdentifier(dmisAlert.getIdentifier()+String.valueOf(System.currentTimeMillis()));

        // post to "all cogs" in the evet the coglist is empty or to the cogs specified.
        try {
            if (postCogs==null){
                cap.postCAPAlert(dmisAlert);
            }else{
                cap.postCAPAlert(dmisAlert,postCogs);
            }

		  } catch (RemoteException e) {
		   	// TODO Auto-generated catch block
		   	e.printStackTrace();
            return false;
		  }      
        return true;
    }
    
    public String getCap(String sender, String identifier, boolean One_1){
        String xml="";
        org.cmis.interopserver.beans.cap1_1.Alert alert1 = null;
        com.incident.cap.Alert incidentAlert = new com.incident.cap.Alert();
        try{
           alert1 = new org.cmis.interopserver.beans.cap1_1.Alert();
           String findString = sender+":"+identifier;
           alert1 = cap.getCAPAlert(findString);
           if ((alert1==null)||(alert1.getIdentifier()==null)){
               System.out.println("Null value returned. Identifier string not found.");
           }else{
               if (alert1.getIdentifier().equals(identifier)){
                 // temporary category test
                // System.out.println("Category length = "+alert1.getInfo(0).getCategory().length) ; 
                 //end temporary category test
                 incidentAlert = ArtCapDmisTranslator.toArtCap(alert1);
                 if (One_1){
                     xml = incidentAlert.toString();
                 }else {
                     xml = incidentAlert.toCAP10();
                 }
               }else{
                   System.out.println("MismatchedIdentifier returned:" +alert1.getIdentifier());
               }
           }                                         
       } catch (Exception ex) {
          ex.printStackTrace();
       }
       return xml;
    }

  // gets all caps over X days old output as XML in 1.1 or 1.0 format
  // with the <?xml version="1.0" encoding="UTF-8"?> stripped fro the front
  // so it does not hurt well-formedness as a set of alerts packed in one XML document 
    
   public  ArrayList <String>  getCapsXdays(int daysAgo, boolean One_1){
 //       Alert alert1 = null;
        Alert[] alertSet = null;
        com.incident.cap.Alert artAlert;
        ArrayList <String> artCapsXML =new ArrayList <String> ();
        Calendar cal;       
        
        try{

            //sets retreival time of the last daysAgodays
            cal=Calendar.getInstance();
            cal=cap.getServerTime();
    		MutableDateTime dt= new MutableDateTime (cal);
            System.out.println("Server Time:"+fmt.print(dt));
            int minusDays = 0 - daysAgo;
            dt.addHours(minusDays);
            System.out.println("Retrieval Time:"+fmt.print(dt));
//            cal.add(Calendar.DATE,minusDays);              
            cal = dt.toGregorianCalendar(); 
            alertSet = cap.getCAPAlerts(cal);

            for (int i=0; i<alertSet.length; i++){
 //               System.out.println(alertSet[i].getSent());
                artAlert = new com.incident.cap.Alert();
                artAlert = ArtCapDmisTranslator.toArtCap(alertSet[i]);
                if (One_1){
//                    artCapsXML.add(artAlert.toString());
                    String temp = artAlert.toString();
                    artCapsXML.add(temp.substring(39));                    
                }else {
//                    artCapsXML.add(artAlert.toCAP10());
                    String temp = artAlert.toCAP10(); 
                    artCapsXML.add(temp.substring(39));                   
                }
  
            }
                   
        }catch (Exception ex) {
             ex.printStackTrace();
        }
        return artCapsXML;
    }
    
    // gets all caps over X days old output as XML in 1.1 or 1.0 format
    // with the <?xml version="1.0" encoding="UTF-8"?> stripped fro the front
    // so it does not hurt well-formedness as a set of alerts packed in one XML document 
    
     public  ArrayList <String> getCapsXHours(int hoursAgo, boolean One_1){
 //         Alert alert1 = null;
          Alert[] alertSet = null;
          com.incident.cap.Alert artAlert;
          ArrayList <String> artCapsXML =new ArrayList <String>();
          Calendar cal;
          
          try{

              //sets retreival time of the last daysAgodays
              cal=Calendar.getInstance();
              cal=cap.getServerTime();
        	  MutableDateTime dt= new MutableDateTime (cal);
              System.out.println("Server Time:"+fmt.print(dt));
              int minusHours = 0 - hoursAgo;
              dt.addHours(minusHours);              
              System.out.println("Retrieval Time:"+fmt.print(dt));
              cal = dt.toGregorianCalendar();             
              alertSet = cap.getCAPAlerts(cal);

              for (int i=0; i<alertSet.length; i++){
   //               System.out.println(alertSet[i].getSent());
                  artAlert = new com.incident.cap.Alert();
                  artAlert = ArtCapDmisTranslator.toArtCap(alertSet[i]);
                  if (One_1){
//                      artCapsXML.add(artAlert.toString());
                      String temp = artAlert.toString();
                      artCapsXML.add(temp.substring(39));                    
                  }else {
//                      artCapsXML.add(artAlert.toCAP10());
                      String temp = artAlert.toCAP10(); 
                      artCapsXML.add(temp.substring(39));                   
                  }
  
              }
                   
          }catch (Exception ex) {
               ex.printStackTrace();
          }
          return artCapsXML;
      }

    // gets all caps posted after the sent date in the parameter list as an Array list of XMLstrings in 1.1
    // or 1.0 format. Only calls the sent time functions.
    
    public  ArrayList <String> getCapsBySentTime(String sentString, boolean One_1, int inMode){

          ArrayList <String>  artCapsXML =new ArrayList <String> ();
          Calendar cal;
          int getMode;
 
    	  MutableDateTime dt= new MutableDateTime (sentString);
        
          cal = dt.toGregorianCalendar();             
         
          System.out.print("String for Conversion:"+sentString+"\n");
          System.out.print("Converted to local time zone: Alerts with sent after:"+fmt.print(dt)+"\n");          
 
          switch (inMode){
             case ALL: getMode = ALL_BY_SENT_DATE;break;
             case POSTED: getMode = POSTED_BY_SENT_DATE;break;
             case RECEIVED: getMode = RECEIVED_BY_SENT_DATE;break;
             case GLOBAL: getMode = GLOBAL_BY_SENT_DATE;break;
             default: getMode = 10;
           }
           
          artCapsXML = getCapsMultiMode(One_1,getMode,cal); 
          return artCapsXML;
      }

    
    
      
      
     // gets all caps posted less than X hours earlier than the current server time. XML in 1.1 or 1.0 format
     // will only call post time functions  
    
     public  ArrayList <String>  getCapsXHoursAgoPostTime(int hoursAgo, boolean One_1, int inMode){

          ArrayList<String>  artCapsXML =new ArrayList<String> ();
          Calendar cal;
          int mode;
          
          try{
 
              //sets retreival time of the last daysAgodays
              cal=Calendar.getInstance();
              cal=cap.getServerTime();
              
        	  MutableDateTime dt= new MutableDateTime (cal);
        	  
              System.out.println("Server Time:"+fmt.print(dt));
              int minusHours = 0 - hoursAgo;
              dt.addHours(minusHours);              
              System.out.println("Retrieval Time:"+fmt.print(dt));
              cal = dt.toGregorianCalendar();             
              
              switch (inMode){
                 case ALL: mode = ALL_BY_POST_DATE;break;
                 case POSTED: mode = POSTED_BY_POST_DATE;break;
                 case RECEIVED: mode = RECEIVED_BY_POST_DATE;break;
                 case GLOBAL: mode = GLOBAL_BY_POST_DATE;break;
                 default: mode = ALL_BY_POST_DATE;
               }
            
              artCapsXML = getCapsMultiMode(One_1,mode,cal); 
                   
          }catch (Exception ex) {
               ex.printStackTrace();
          }
          return artCapsXML;
      }

    // gets all caps posted less than X days earlier than the current server time XML in 1.1 or 1.0 format
    // will only call post time functions  
    
    public  ArrayList<String>  getCapsXDaysAgoPostTime(int daysAgo, boolean One_1, int inMode){

         ArrayList<String>  artCapsXML =new ArrayList<String> ();
         Calendar cal;
         int mode;
          
         try{
 
             //sets retreival time of the last daysAgodays
             cal=Calendar.getInstance();
             cal=cap.getServerTime();
       	  MutableDateTime dt= new MutableDateTime (cal);
    	  
          System.out.println("Server Time:"+fmt.print(dt));
          int minusDays = 0 - daysAgo;
          dt.addHours(minusDays);              
          System.out.println("Retrieval Time:"+fmt.print(dt));
          cal = dt.toGregorianCalendar();            
            
             switch (inMode){
                case ALL: mode = ALL_BY_POST_DATE;break;
                case POSTED: mode = POSTED_BY_POST_DATE;break;
                case RECEIVED: mode = RECEIVED_BY_POST_DATE;break;
                case GLOBAL: mode = GLOBAL_BY_POST_DATE;break;
                default: mode = ALL_BY_POST_DATE;
              }
            
             artCapsXML = getCapsMultiMode(One_1,mode,cal); 
                   
         }catch (Exception ex) {
              ex.printStackTrace();
         }
         return artCapsXML;
     }




    // Gets an ArrayList of CAP messages from any of the CAP 1.1 interfaces
    
     public  ArrayList <String>  getCapsMultiMode(boolean One_1, int mode, Calendar cal){
 //         org.cmis.interopserver.beans.cap1_1.Alert alert1 = null;
          org.cmis.interopserver.beans.cap1_1.Alert[] alertSet = null;
          com.incident.cap.Alert artAlert;
          ArrayList<String>  artCapsXML =new ArrayList<String> ();
          
          try{
              switch (mode){
                case ALL_BY_SENT_DATE: alertSet = cap.getCAPAlerts(cal);break;                
                case POSTED_BY_SENT_DATE: alertSet = cap.getAlertsSentBySentDate(cal);break;
                case RECEIVED_BY_SENT_DATE: alertSet = cap.getMyCogsAlertsBySentDate(cal);break;
                case GLOBAL_BY_SENT_DATE: alertSet = cap.getCAPAlertsGlobalBySentDate(cal);break;
                case ALL_BY_POST_DATE: alertSet = cap.getCAPAlertsByPostedDate(cal);break;
                case POSTED_BY_POST_DATE: alertSet = cap.getAlertsSentByPostedDate(cal);break;
                case RECEIVED_BY_POST_DATE : alertSet= cap.getMyCogsAlertsByPostedDate(cal);break;
                case GLOBAL_BY_POST_DATE : alertSet= cap.getCAPAlertsGlobalByPostedDate(cal);break;
                default: alertSet =null; 
              }

              for (int i=0; i<alertSet.length; i++){
   //               System.out.println(alertSet[i].getSent());
                  artAlert = new com.incident.cap.Alert();
                  artAlert = ArtCapDmisTranslator.toArtCap(alertSet[i]);
                  if (One_1){
//                      artCapsXML.add(artAlert.toString());
                      String temp = artAlert.toString();
                      artCapsXML.add(temp.substring(39));                    
                  }else {
//                      artCapsXML.add(artAlert.toCAP10());
                      String temp = artAlert.toCAP10(); 
                      artCapsXML.add(temp.substring(39));                   
                  }
  
              }
                   
          }catch (Exception ex) {
               ex.printStackTrace();
          }
          return artCapsXML;
      }




    
    public String getAvaliableCogsXML(){
        SimpleCOG [] cogSet = null;
        String cogsXML = null;          
        try{
            cogSet = cap.getCogs();
            cogsXML="<cogs>" +"\n";
            System.out.println("length = "+cogSet.length);
            for (int i=0; i<cogSet.length; i++){
 //               SimpleCOG sc = new SimpleCOG();
                cogsXML= cogsXML +"   <cog>" +"\n";
                cogsXML= cogsXML +"      <cogId>"+cogSet[i].getId()+"</cogId>" +"\n";
                cogsXML= cogsXML +"      <cogName>"+cogSet[i].getName()+"</cogName>" +"\n";
                cogsXML= cogsXML +"   </cog>" +"\n";
            }
            cogsXML=cogsXML + "</cogs>" +"\n";                   
        }catch (Exception ex) {
             ex.printStackTrace();
        }
        return cogsXML;
    }

    public String getMyCogXML(){
        SimpleCOG  cog = null;
        String cogXML = null;          
        try{
            cog = cap.getMyCog();
            cogXML= "<cog>" +"\n";
            cogXML= cogXML +"   <cogId>"+cog.getId()+"</cogId>" +"\n";
            cogXML= cogXML +"   <cogName>"+cog.getName()+"</cogName>" +"\n";
            cogXML= cogXML +"</cog>" +"\n";
        }catch (Exception ex) {
             ex.printStackTrace();
        }
        return cogXML;
    }
            
}
